/*
* Copyright (C) 2015 University of Nizhni Novgorod
* This file is part of the PMORSy ordering library, v 1.2.0
* 
* morsy_coarsening.c - coarsening rotines 
* 
* This file may be used under the terms of the GNU Lesser General Public 
* License version 2.1 as published by the Free Software Foundation 
* and appearing in the file LICENSE.LGPL included in the packaging of this 
* file. Please review the following information to ensure the GNU Lesser 
* General Public License version 2.1 requirements will be met: 
* http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
*/


#ifndef __PMORSY_COARSENING_H__
#define __PMORSY_COARSENING_H__

#include "morsy_routines.h"
#include "morsy_types.h"


int Coarsening(GraphStructure* Graph, GraphStructure** CoarsenedQueque,
               NestedDissectionParameters* params);

int RandomMatching(GraphStructure* Graph, 
                    int* adjncyVisitOrder, int* visitOrder, 
                    MORSY_RNG_PTR stream);

int HeavyEdgeMatching(GraphStructure* Graph, 
                    int* adjncyVisitOrder, int* visitOrder, 
                    MORSY_RNG_PTR stream);

int HeavyCliqueMatching(GraphStructure* Graph, 
                    int* adjncyVisitOrder, int* visitOrder, 
                    MORSY_RNG_PTR stream);

#endif