/*
* Copyright (C) 2015 University of Nizhni Novgorod
* This file is part of the PMORSy ordering library, v 1.2.0
* 
* morsy_compression.h - matrix compression 
* 
* This file may be used under the terms of the GNU Lesser General Public 
* License version 2.1 as published by the Free Software Foundation 
* and appearing in the file LICENSE.LGPL included in the packaging of this 
* file. Please review the following information to ensure the GNU Lesser 
* General Public License version 2.1 requirements will be met: 
* http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
*/


#ifndef __PMORSY_COMPRESSION_H__
#define __PMORSY_COMPRESSION_H__

#include "morsy_types.h"


int GraphCompressionProcedure(int* GraphAdjncy, int* GraphXadj,
                              int** NewGraphAdjncy, int** NewGraphXadj,
                              CompressionStructure* Compressed, int n);

void MallocCompressionStructure(CompressionStructure* Compressed, int n);

void FreeCompressionStructure(CompressionStructure* Compressed);

#endif