/*
* Copyright (C) 2015 University of Nizhni Novgorod
* This file is part of the PMORSy ordering library, v 1.2.0
* 
* morsy_disjointSets.h - disjoint sets data structure declaration
* 
* This file may be used under the terms of the GNU Lesser General Public 
* License version 2.1 as published by the Free Software Foundation 
* and appearing in the file LICENSE.LGPL included in the packaging of this 
* file. Please review the following information to ensure the GNU Lesser 
* General Public License version 2.1 requirements will be met: 
* http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
*
*/


#ifndef __PMORSY_DISJOINT_SETS_H__
#define __PMORSY_DISJOINT_SETS_H__

struct
{
  int* head;
  int* next;
  int* setSize;
  int n;
} typedef DisjointSetList;

void InitializeDisjointSets(DisjointSetList* DisjointSets, int n);

void MakeAllDisjointSets(DisjointSetList* DisjointSets);

void UnionDisjointSets(DisjointSetList* DisjointSets, int x, int y);

void FreeDisjointSet(DisjointSetList* DisjointSets);

#endif