/*
* Copyright (C) 2015 University of Nizhni Novgorod
* This file is part of the PMORSy ordering library, v 1.2.0
* 
* morsy_gainsOperations.h - operations with gains structure
* 
* This file may be used under the terms of the GNU Lesser General Public 
* License version 2.1 as published by the Free Software Foundation 
* and appearing in the file LICENSE.LGPL included in the packaging of this 
* file. Please review the following information to ensure the GNU Lesser 
* General Public License version 2.1 requirements will be met: 
* http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
*/


#ifndef __PMORSY_GAINS_OPERATIONS_H__
#define __PMORSY_GAINS_OPERATIONS_H__

#include "morsy_types.h"

void InitializeGainsStructure(GainsStructure* Gains, int n);

void InsertGain(GainsStructure* Gains, int node, int gain);

void DeleteGain(GainsStructure* Gains, int node);

void UpdateGain(GainsStructure* Gains, int node, int newGain);

void ReinitializeGainsStructure(GainsStructure* Gains, int n);

void MallocGainsStructure(GainsStructure* Gains, int minGain, int maxGain, 
                          int n);

void FreeGainsStructure(GainsStructure* Gains);

int FindBestPrimitiveMove(GainsStructure* Gains);

int ViewBestPrimitiveMove(GainsStructure* Gains);

#endif