/*
* Copyright (C) 2015 University of Nizhni Novgorod
* This file is part of the PMORSy ordering library, v 1.2.0
* 
* morsy_initPartitioning.h - routines for initial graph partitioning
* 
* This file may be used under the terms of the GNU Lesser General Public 
* License version 2.1 as published by the Free Software Foundation 
* and appearing in the file LICENSE.LGPL included in the packaging of this 
* file. Please review the following information to ensure the GNU Lesser 
* General Public License version 2.1 requirements will be met: 
* http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
*/


#ifndef __PMORSY_INIT_PARTITIONING_H__
#define __PMORSY_INIT_PARTITIONING_H__

#include "morsy_types.h"

void BFSPartition(PartitionStructure* Partition,  
                  GraphStructure* Graph, MORSY_RNG_PTR stream); // # 0

void GraphGrowingPartition(PartitionStructure* Partition,  
                  GraphStructure* Graph, MORSY_RNG_PTR stream); // # 1

void GreedyGraphGrowingPartition(PartitionStructure* Partition,  
                   GraphStructure* Graph, MORSY_RNG_PTR stream); // # 2

void KerniganLinPartition(PartitionStructure* Partition,  
                          GraphStructure* Graph, MORSY_RNG_PTR stream); // # 3


#endif