/*
* Copyright (C) 2015 University of Nizhni Novgorod
* This file is part of the PMORSy ordering library, v 1.2.0
* 
* morsy_randomGenerator.h - random numbers generator declaration
* 
* This file may be used under the terms of the GNU Lesser General Public 
* License version 2.1 as published by the Free Software Foundation 
* and appearing in the file LICENSE.LGPL included in the packaging of this 
* file. Please review the following information to ensure the GNU Lesser 
* General Public License version 2.1 requirements will be met: 
* http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
*/

#ifndef __PMORSY_RANDOM_GENERATOR_H__
#define __PMORSY_RANDOM_GENERATOR_H__

#include "morsy_types.h"

void GetRandomVector(MORSY_RNG_PTR stream, int* vector, int size, int low, 
                     int high);

void CreateRandomPermutationFromVector(int* vector, int* randomVector, 
                                       int size);

void InitializeRandomGenerators(MORSY_RNG_PTR** stream, int nStreams);

void FinalizeRandomGenerators(MORSY_RNG_PTR** stream, int nStreams);


#endif

