/*
* Copyright (C) 2015 University of Nizhni Novgorod
* This file is part of the PMORSy ordering library, v 1.2.0
* 
* morsy_subgraphsCreation.h - finding subgraphs after separator deleting 
* 
* This file may be used under the terms of the GNU Lesser General Public 
* License version 2.1 as published by the Free Software Foundation 
* and appearing in the file LICENSE.LGPL included in the packaging of this 
* file. Please review the following information to ensure the GNU Lesser 
* General Public License version 2.1 requirements will be met: 
* http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
*/


#ifndef __PMORSY_SUBGRAPHS_CREATION_H__
#define __PMORSY_SUBGRAPHS_CREATION_H__

#include "morsy_types.h"
#include "morsy_connectedComponents.h"

int FindSubgraphs(GraphStructure* graph, PartitionStructure* partition, 
                   GraphStructure*** subgraphs);

int FindConnectedComponents(int* Xadj, int* Adjncy, int nVertexes,
                            ConnectedComponentsStructure* CC);

#endif