#include "reorderingRoutines.h"

void WriteGraphToFile(char* fileName, int* adjncy, int* xadj, int n)
{
  FILE* file;
  int i;
  int nz = xadj[n];

  file = fopen(fileName, "w+");
  fprintf(file, "%d %d\n", n, xadj[n]);
  for (i = 0; i < nz; i++)
  {
    fprintf(file, "%d ", adjncy[i]);
  }
  fprintf(file, "\n");

  for (i = 0; i < n + 1; i++)
  {
    fprintf(file, "%d ", xadj[i]);
  }
  fclose(file);
}

void ReadGraphFromFile(char* fileName, int** adjncy, int** xadj, int* n, int* nz)
{
  FILE* file;
  int i;

  file = fopen(fileName, "r+");

  fscanf(file, "%d %d\n", n, nz);

  *adjncy = (int*)malloc(sizeof(int) * (*nz));
  *xadj   = (int*)malloc(sizeof(int) * (*n + 1));
  for (i = 0; i < *nz; i++)
  {
    fscanf(file, "%d ", &(*adjncy)[i]);
  }
  fscanf(file, "\n");
  for (i = 0; i < *n + 1; i++)
  {
    fscanf(file, "%d ", &(*xadj)[i]);
  }
  fclose(file);
}

int WritePermutationToFile(char* fileName, int* iperm, int n)
{
  FILE* file = fopen(fileName, "w+");
  int i;
  
  if (!file)
  {
    fclose(file);
    return 1;
  }
  for (i = 0; i < n; i++)
    fprintf(file, "%d ", iperm[i]);
  fclose(file);

  return 0;
}

